package ru.landgrafhomyak.bgtu.computer_graphics1.model_builder

class Polygon(
	val textureType: TextureType,
	vararg val vertexes: PolygonVertex
) {
	init {
		require(this.vertexes.size >= 3) { "Polygon should has at least 3 vertexes" }
	}

	class PolygonVertex(
		val modelVertex: Point3F,
		val textureVertex: Point2F
	) {
		operator fun component1() = this.modelVertex
		operator fun component2() = this.textureVertex

		constructor(mx: Float, my: Float, mz: Float, tx: Float, ty: Float) :
				this(Point3F(mx, my, mz), Point2F(tx, ty))

		constructor(m: Point3F, tx: Float, ty: Float) :
				this(m, Point2F(tx, ty))

		constructor(mx: Float, my: Float, mz: Float, t: Point2F) :
				this(Point3F(mx, my, mz), t)
	}


}